#ifndef _SNAILSHELLEXT_APPEARED_
#define _SNAILSHELLEXT_APPEARED_

#include <windows.h>
#include <shlobj.h>
#include <string>
#include <map>

class SnailShellExt : public IContextMenu, public IShellExtInit
{
public:
    SnailShellExt(void);
    ~SnailShellExt(void);

public:
    //IUnknown members
    STDMETHODIMP QueryInterface(REFIID iid, LPVOID FAR *object);
    STDMETHODIMP_(ULONG) AddRef(void);
    STDMETHODIMP_(ULONG) Release(void);

    //IContextMenu members
    STDMETHODIMP QueryContextMenu(HMENU hMenu, UINT indexMenu,
        UINT idCmdFirst, UINT idCmdLast, UINT uFlags);

    STDMETHODIMP InvokeCommand(LPCMINVOKECOMMANDINFO lpcmi);

    STDMETHODIMP GetCommandString(UINT idCmd, UINT uFlags,
        UINT FAR *reserved, LPSTR pszName, UINT cchMax);

    //IShellExtInit methods
    STDMETHODIMP Initialize(LPCITEMIDLIST pIDFolder,
        LPDATAOBJECT pDataObj, HKEY hKeyID);

public:
    static bool CanUnloadNow(void);

private:
    ULONG _ref_counter;
    LPDATAOBJECT m_pDataObj;
    std::string _filename;
    std::map<UINT, std::string> _command;

private:
    std::string _compile;
    std::string _compile_desc;
    std::string _clean;
    std::string _clean_desc;
    std::string _self_path;
    UINT _config_count;

private:
    static ULONG _global_ref_counter;
};

#endif // _SNAILSHELLEXT_APPEARED_
