// Last Modified: 2005-08-10 18:10:19
#include "in_kmk_util.h"
#include "stringutil.h"

// ȡַ˵Ŀո tabַǰ˵İ׿ո񳤶ȡ
// buffer ָֻڴ
int trim(char *buffer, int tab_stop)
{
    int position = 0;
    char *scanptr = buffer;
    char *workptr = buffer;
    char *endptr = buffer;
    while (*scanptr == ' ' || *scanptr == '\t')
    {
        if (*scanptr == ' ')
            ++position;
        else if (*scanptr == '\t')
            position = ((position / tab_stop) + 1) * tab_stop;
        ++scanptr;
    }
    while (*scanptr)
    {
        if (*scanptr != ' ' && *scanptr != '\t')
            endptr = workptr + 1;
        *(workptr++) = *(scanptr++);
    }
    *endptr = 0;
    return position;
}

// ȫ·ȡļ
std::string getfilename(std::string fullpath)
{
    std::string::size_type position;
    if ((position = fullpath.find_last_of('/'))
        == std::string::npos)
        return fullpath;
    else
        return fullpath.substr(position + 1);
}

// ȫ·ȡļ·ֵҶ˵·ָ
std::string getpathname(std::string fullpath)
{
    std::string::size_type position;
    if ((position = fullpath.find_last_of('/'))
        == std::string::npos)
        return std::string("");
    else
        return fullpath.substr(0, position + 1);
}

//  str ַָ顣
std::list<std::string> split(std::string str,
    const char *const splitter)
{
    std::list<std::string> result;
    std::string token;

    bool escaped = false;
    // 0: 
    // 1:  '
    // 2: ˫ "
    // 3: Ʋ   `
    int quoted = 0;

    for (std::string::size_type scan = 0; scan < str.size(); ++scan)
    {
        if (escaped)
        {
            token += str[scan];
            escaped = false;
        }
        else
        {
            if (quoted > 0)
            {
                switch (str[scan])
                {
                case '\\':
                    escaped = true;
                    token += str[scan];
                    break;
                case '\'':
                    if (quoted == 1)
                        quoted = 0;
                    token += str[scan];
                    break;
                case '\"':
                    if (quoted == 2)
                        quoted = 0;
                    token += str[scan];
                    break;
                case '`':
                    if (quoted == 3)
                        quoted = 0;
                    token += str[scan];
                    break;
                default:
                    token += str[scan];
                    break;
                }
            }
            else
            {
                switch (str[scan])
                {
                case '\'':
                    quoted = 1;
                    token += str[scan];
                    break;
                case '\"':
                    quoted = 2;
                    token += str[scan];
                    break;
                case '`':
                    quoted = 3;
                    token += str[scan];
                    break;
                case '\\':
                    escaped = true;
                    token += str[scan];
                    break;
                default:
                    if (strchr(splitter, str[scan]) == NULL)
                        token += str[scan];
                    else
                    {
                        if (token.size())
                        {
                            result.push_back(token);
                            token = "";
                        }
                    }
                    break;
                }
            }
        }
    }

    if (token.size())
    {
        result.push_back(token);
        token = "";
    }

    return result;
}

// Ŀ¼
std::string path_simplify(std::string curpath, std::string path,
    std::string _platform)
{
    if (_platform == "win32")
    {
        if (path.size() > 2 && path[1] == ':')
            return path;
        curpath = euc::replace_all(curpath, '\\', '/');
        path = euc::replace_all(path, '\\', '/');
    }
    if (path.size() > 1 && path[0] == '/')
        return path;

    if (curpath[curpath.size() - 1] != '/')
        curpath += "/";

    std::list<std::string> tokenized_path = split(curpath + path, "/");
    std::list<std::string> result_path;
    std::string result;

    for (std::list<std::string>::iterator ite = tokenized_path.begin();
        ite != tokenized_path.end(); ++ite)
    {
        if (*ite == ".")
            continue;
        if (*ite == "..")
        {
            if (result_path.size() && result_path.back() != "..")
                result_path.pop_back();
            else
                result_path.push_back("..");
            continue;
        }
        result_path.push_back(*ite);
    }

    for (std::list<std::string>::iterator ite = result_path.begin();
        ite != result_path.end(); ++ ite)
        result += "/" + *ite;

    if (result.size() > 1)
        result = result.substr(1);

    return result;
}
