/*  ʵ(EUC)Ա ļ
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include "fileutil.h"
#include "stringutil.h"

#if defined(UNIX) || defined(LINUX)
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#else
#include <windows.h>
#endif

namespace euc
{

#if defined(WIN32)
const char PATH_SEPARATOR = '\\';
#elif defined(UNIX) || defined(LINUX)
const char PATH_SEPARATOR = '/';
#else
#error 'Only Windows, Unix and Linux are supported'
#endif

// ȫ·ȡļ
std::string getfilename(std::string fullpath)
{
    std::string::size_type position;
    if ((position = fullpath.find_last_of(PATH_SEPARATOR))
        == std::string::npos)
        return fullpath;
    else
        return fullpath.substr(position + 1);
}

// ȫ·ȡļ·ֵҶ˵·ָ
std::string getpathname(std::string fullpath)
{
    std::string::size_type position;
    if ((position = fullpath.find_last_of(PATH_SEPARATOR))
        == std::string::npos)
        return std::string("");
    else
        return fullpath.substr(0, position + 1);
}

// ȫ·ȡļ
std::string getfilename(const char *const fullpath)
{
    std::string path = fullpath;
    return getfilename(path);
}

// ȫ·ȡļ·ֵҶ˵·ָ
std::string getpathname(const char *const fullpath)
{
    std::string path = fullpath;
    return getpathname(path);
}

// Ŀ¼
std::string path_simplify(std::string curpath, std::string path)
{
    std::string token;
    std::string result;
    std::string::size_type i;
    std::string ps;
    ps += PATH_SEPARATOR;

    if (path == "")
        return curpath;

    if (path[0] == '/'
#ifdef WIN32
        || path[0] == '\\'
#endif // WIN32
        )
    {
        result = ps;
        i = 1;
    }
    else
    {
        result = curpath;
        i = 0;
    }

    for ( ; i < path.size(); ++i)
    {
        switch (path[i])
        {
#ifdef WIN32
        case '\\':
#endif
        case '/':
            if (token == "..")
            {
                if (result != ps)
                {
                    result = result.substr(0,
                        result.rfind(PATH_SEPARATOR, result.size() - 2)) + ps;
                }
            }
            else if (token != "" && token != ".")
            {
                result += (token + ps);
            }
            token = "";
            break;
        default:
            token += path[i];
        }
    }

    if (token != "")
    {
        if (token == "..")
        {
            if (result != ps)
            {
                result = result.substr(0,
                    result.rfind(PATH_SEPARATOR, result.size() - 2)) + ps;
            }
        }
        else if (token != "" && token != ".")
        {
            result += token;
        }
    }

    return result;
}

// Ŀ¼
std::string path_simplify(const char *const curpath, const char *const path)
{
    return path_simplify(std::string(curpath), std::string(path));
}

// ļнȡչļ
std::string get_mainname(std::string filename)
{
    std::string name = getfilename(filename);
    std::string::size_type pos = name.find_last_of('.');
    if (pos == std::string::npos)
        return name;
    return name.substr(0, pos);
}

// ļнȡչļ
std::string get_mainname(const char *const filename)
{
    return get_mainname(std::string(filename));
}

// ļнȡչ
std::string get_extension(std::string filename)
{
    std::string::size_type pos = filename.find_last_of('.');
    if (pos == std::string::npos)
        return std::string();
    if (pos == filename.size() - 1)
        return std::string();
    return filename.substr(pos + 1);
}

// ļнȡչ
std::string get_extension(const char *const filename)
{
    return get_extension(std::string(filename));
}

// ļǷڡ0 Ϊڣ1 ΪļУ2 Ϊļ
int file_exists(const char *const path)
{
#if defined(UNIX) || defined(LINUX)
    struct stat st;
    if (stat(path, &st) != 0)
        return 0;

    if (S_ISDIR(st.st_mode & S_IFMT))
        return 1;

    return 2;
#else
    WIN32_FIND_DATA wfd;

    std::string item(euc::rtrim(path, '\\'));
    if (item.find('*') != std::string::npos
        || item.find('?') != std::string::npos)
        return 0;

    if (item[1] == ':' && item.size() == 2)
    {
        UINT type = GetDriveType(path);
        if (type == DRIVE_NO_ROOT_DIR || type == DRIVE_UNKNOWN)
            return 0;
        return 1;
    }

    HANDLE handle;
    if ((handle = FindFirstFile(item.c_str(), &wfd))
        == INVALID_HANDLE_VALUE)
        return 0;
    FindClose(handle);

    if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
        return 1;
    return 2;
#endif
}

// ļǷڡ0 Ϊڣ1 ΪļУ2 Ϊļ
int file_exists(std::string path)
{
    return file_exists(path.c_str());
}

} // namespace
